Bug 819965 - THP page migration
THP page migration
Status: ASSIGNED
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel (Show other bugs)
7.0
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Aristeu Rozanski
Wang Shu
: FutureFeature, Reopened
Depends On:
Blocks: 817917 919431 1296180 1394638 1469551 1032535 1032538 1071730
  Show dependency treegraph
 
Reported: 2012-05-08 14:28 EDT by Rik van Riel
Modified: 2017-08-21 04:39 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-03 17:16:09 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Rik van Riel 2012-05-08 14:28:49 EDT
Description of problem:

Currently, page migration breaks 2MB pages into 4kB pages, which then have to be reassembled again at the destination. This negates a lot of the performance benefits of doing NUMA relocations in the first place.

2MB transparent hugepages should stay intact across page migration.

We can use the same bit that is used to protect 2MB->4kB and 4kB->2MB transitions to block out page accesses during a 2MB->2MB transition.
Comment 5 Johannes Weiner 2013-09-03 17:16:09 EDT
THP-preserving migration is included in the NUMA balancing code.
Comment 6 Rik van Riel 2013-11-20 08:45:13 EST
Johannes,

if you look unmap_and_move, which is indirectly called from sys_migrate_pages, you will see that it does NOT preserve THP on migration. There is a reason this bug was opened separately.
Comment 7 Johannes Weiner 2013-11-21 12:03:02 EST
(In reply to Rik van Riel from comment #6)
> Johannes,
> 
> if you look unmap_and_move, which is indirectly called from
> sys_migrate_pages, you will see that it does NOT preserve THP on migration.
> There is a reason this bug was opened separately.

My bad, I was under the assumption this was to track the side-project of adding THP-preserving migration to AutoNUMA.

I'll dig up the patches.
Comment 8 Ludek Smid 2014-06-26 06:42:53 EDT
This request was resolved in Red Hat Enterprise Linux 7.0.

Contact your manager or support representative in case you have further questions about the request.
Comment 9 Ludek Smid 2014-06-26 07:16:36 EDT
The comment above is incorrect. The correct version is bellow.
I'm sorry for any inconvenience.
---------------------------------------------------------------

This request was NOT resolved in Red Hat Enterprise Linux 7.0.

Contact your manager or support representative in case you need
to escalate this bug.

Note You need to log in before you can comment on or make changes to this bug.